C# 클래스 SolidworksAddinFramework.Geometry.CurveExtension

파일 보기 프로젝트 열기: Weingartner/SolidworksAddinFramework

공개 메소드들

메소드 설명
ApplyTransform ( this body, Matrix4x4 t ) : void
ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
CurveBoundsDoubleArray ( this curve ) : double[]
DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
Domain ( this curve ) : double[]

Return the domain of the curve. ie the [startParam, endParam]

EndPoint ( this curve, int derivatives ) : List
EndPoint ( this curve ) : System.Vector3
FindMinimumRadius ( this curve ) : MinimumRadiusResult
GetCurveTs ( this edge ) : ICurve
GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List

Approximation. Be carefull

GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
Length ( this curve ) : double

Return the length of the curve between the start and end parameters.

PointAt ( this curve, double t, int derivatives ) : List

Return the point at parameter value t on the curve.

PointAt ( this curve, double t ) : System.Vector3
PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
PointAtDistanceFrom ( this c, double t0, double distance ) : double

Should solve

PointParamAt ( this curve, double t ) : PointParam
PointTangentAt ( this c, double t ) : PointDirection3
ReverseEvaluate ( this curve, System.Vector3 p ) : double
StartPoint ( this curve, int derivatives ) : List
StartPoint ( this curve ) : System.Vector3

비공개 메소드들

메소드 설명
GetTessPotsAsVector3 ( ICurve curve, double chordTol, double lengthTol, double startPt, double midPt ) : IEnumerable
MakeEdge ( IList edge ) : Edge3

메소드 상세

ApplyTransform() 공개 정적인 메소드

public static ApplyTransform ( this body, Matrix4x4 t ) : void
body this
t Matrix4x4
리턴 void

ClosestDistanceBetweenTwoCurves() 공개 정적인 메소드

public static ClosestDistanceBetweenTwoCurves ( IMathUtility m, ICurve curve0, ICurve curve1 ) : EdgeDistance
m IMathUtility
curve0 ICurve
curve1 ICurve
리턴 EdgeDistance

ClosestPointOn() 공개 정적인 메소드

public static ClosestPointOn ( this curve, System.Vector3 v ) : PointParam
curve this
v System.Vector3
리턴 PointParam

ClosestPointOn() 공개 정적인 메소드

public static ClosestPointOn ( this curve, double x, double y, double z ) : PointParam
curve this
x double
y double
z double
리턴 PointParam

ClosestPointTangentOn() 공개 정적인 메소드

public static ClosestPointTangentOn ( this curve, System.Vector3 v ) : PointDirection3
curve this
v System.Vector3
리턴 PointDirection3

ClosestPointToRay() 공개 정적인 메소드

public static ClosestPointToRay ( this curve, PointDirection3 ray, double tol = 1e-9 ) : PointParamWithRayProjection
curve this
ray PointDirection3
tol double
리턴 PointParamWithRayProjection

CreateTrimmedCurve() 공개 정적인 메소드

public static CreateTrimmedCurve ( this curve, double t0, double t1 ) : ICurve
curve this
t0 double
t1 double
리턴 ICurve

CurveBoundsDoubleArray() 공개 정적인 메소드

public static CurveBoundsDoubleArray ( this curve ) : double[]
curve this
리턴 double[]

DisplayUndoable() 공개 정적인 메소드

public static DisplayUndoable ( this curve, IModelDoc2 doc, Color color, double thickness, double chordTol = 1e-6, double lengthTol, int layer ) : IDisposable
curve this
doc IModelDoc2
color Color
thickness double
chordTol double
lengthTol double
layer int
리턴 IDisposable

DisplayUndoable() 공개 정적인 메소드

public static DisplayUndoable ( this line, IModelDoc2 doc, Color color, double thickness = 1, int layer ) : IDisposable
line this
doc IModelDoc2
color Color
thickness double
layer int
리턴 IDisposable

Domain() 공개 정적인 메소드

Return the domain of the curve. ie the [startParam, endParam]
public static Domain ( this curve ) : double[]
curve this
리턴 double[]

EndPoint() 공개 정적인 메소드

public static EndPoint ( this curve, int derivatives ) : List
curve this
derivatives int
리턴 List

EndPoint() 공개 정적인 메소드

public static EndPoint ( this curve ) : System.Vector3
curve this
리턴 System.Vector3

FindMinimumRadius() 공개 정적인 메소드

public static FindMinimumRadius ( this curve ) : MinimumRadiusResult
curve this
리턴 MinimumRadiusResult

GetCurveTs() 공개 정적인 메소드

public static GetCurveTs ( this edge ) : ICurve
edge this
리턴 ICurve

GetPlanePoints() 공개 정적인 메소드

public static GetPlanePoints ( this curve, double position, System.Vector3 &pNormal, System.Vector3 &pCurve, System.Vector3 &pAxis ) : void
curve this
position double
pNormal System.Vector3
pCurve System.Vector3
pAxis System.Vector3
리턴 void

GetPointsByLength() 공개 정적인 메소드

Approximation. Be carefull
public static GetPointsByLength ( this curve, double pointDistance, DoubleRange flankHelixDomain = null ) : List
curve this
pointDistance double
flankHelixDomain AForge.DoubleRange
리턴 List

GetTessPoints() 공개 정적인 메소드

public static GetTessPoints ( this curve, double chordTol, double lengthTol, RangeDouble domain = null ) : System.Vector3[]
curve this
chordTol double
lengthTol double
domain RangeDouble
리턴 System.Vector3[]

Length() 공개 정적인 메소드

Return the length of the curve between the start and end parameters.
public static Length ( this curve ) : double
curve this
리턴 double

PointAt() 공개 정적인 메소드

Return the point at parameter value t on the curve.
public static PointAt ( this curve, double t, int derivatives ) : List
curve this
t double
derivatives int
리턴 List

PointAt() 공개 정적인 메소드

public static PointAt ( this curve, double t ) : System.Vector3
curve this
t double
리턴 System.Vector3

PointAtDistanceFrom() 공개 정적인 메소드

public static PointAtDistanceFrom ( this c, System.Vector3 p0, double distance ) : double
c this
p0 System.Vector3
distance double
리턴 double

PointAtDistanceFrom() 공개 정적인 메소드

Should solve
public static PointAtDistanceFrom ( this c, double t0, double distance ) : double
c this
t0 double
distance double
리턴 double

PointParamAt() 공개 정적인 메소드

public static PointParamAt ( this curve, double t ) : PointParam
curve this
t double
리턴 PointParam

PointTangentAt() 공개 정적인 메소드

public static PointTangentAt ( this c, double t ) : PointDirection3
c this
t double
리턴 PointDirection3

ReverseEvaluate() 공개 정적인 메소드

public static ReverseEvaluate ( this curve, System.Vector3 p ) : double
curve this
p System.Vector3
리턴 double

StartPoint() 공개 정적인 메소드

public static StartPoint ( this curve, int derivatives ) : List
curve this
derivatives int
리턴 List

StartPoint() 공개 정적인 메소드

public static StartPoint ( this curve ) : System.Vector3
curve this
리턴 System.Vector3